Index: branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncCavlc.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 1200)
@@ -813,6 +886,65 @@
   }
 
-#if !H_MV
-  WRITE_FLAG( 0, "sps_extension_flag" );
+#if !NH_MV
+  Bool sps_extension_present_flag=false;
+  Bool sps_extension_flags[NUM_SPS_EXTENSION_FLAGS]={false};
+
+  sps_extension_flags[SPS_EXT__REXT] = pcSPS->getSpsRangeExtension().settingsDifferFromDefaults();
+
+  // Other SPS extension flags checked here.
+
+  for(Int i=0; i<NUM_SPS_EXTENSION_FLAGS; i++)
+  {
+    sps_extension_present_flag|=sps_extension_flags[i];
+  }
+
+  WRITE_FLAG( (sps_extension_present_flag?1:0), "sps_extension_present_flag" );
+
+  if (sps_extension_present_flag)
+  {
+#if ENC_DEC_TRACE || RExt__DECODER_DEBUG_BIT_STATISTICS
+    static const char *syntaxStrings[]={ "sps_range_extension_flag",
+      "sps_multilayer_extension_flag",
+      "sps_extension_6bits[0]",
+      "sps_extension_6bits[1]",
+      "sps_extension_6bits[2]",
+      "sps_extension_6bits[3]",
+      "sps_extension_6bits[4]",
+      "sps_extension_6bits[5]" };
+#endif
+
+    for(Int i=0; i<NUM_SPS_EXTENSION_FLAGS; i++)
+    {
+      WRITE_FLAG( sps_extension_flags[i]?1:0, syntaxStrings[i] );
+    }
+
+    for(Int i=0; i<NUM_SPS_EXTENSION_FLAGS; i++) // loop used so that the order is determined by the enum.
+    {
+      if (sps_extension_flags[i])
+      {
+        switch (SPSExtensionFlagIndex(i))
+        {
+        case SPS_EXT__REXT:
+          {
+            const TComSPSRExt &spsRangeExtension=pcSPS->getSpsRangeExtension();
+
+            WRITE_FLAG( (spsRangeExtension.getTransformSkipRotationEnabledFlag() ? 1 : 0),      "transform_skip_rotation_enabled_flag");
+            WRITE_FLAG( (spsRangeExtension.getTransformSkipContextEnabledFlag() ? 1 : 0),       "transform_skip_context_enabled_flag");
+            WRITE_FLAG( (spsRangeExtension.getRdpcmEnabledFlag(RDPCM_SIGNAL_IMPLICIT) ? 1 : 0), "implicit_rdpcm_enabled_flag" );
+            WRITE_FLAG( (spsRangeExtension.getRdpcmEnabledFlag(RDPCM_SIGNAL_EXPLICIT) ? 1 : 0), "explicit_rdpcm_enabled_flag" );
+            WRITE_FLAG( (spsRangeExtension.getExtendedPrecisionProcessingFlag() ? 1 : 0),       "extended_precision_processing_flag" );
+            WRITE_FLAG( (spsRangeExtension.getIntraSmoothingDisabledFlag() ? 1 : 0),            "intra_smoothing_disabled_flag" );
+            WRITE_FLAG( (spsRangeExtension.getHighPrecisionOffsetsEnabledFlag() ? 1 : 0),       "high_precision_offsets_enabled_flag" );
+            WRITE_FLAG( (spsRangeExtension.getPersistentRiceAdaptationEnabledFlag() ? 1 : 0),   "persistent_rice_adaptation_enabled_flag" );
+            WRITE_FLAG( (spsRangeExtension.getCabacBypassAlignmentEnabledFlag() ? 1 : 0),       "cabac_bypass_alignment_enabled_flag" );
+          break;
+          }
+        default:
+          assert(sps_extension_flags[i]==false); // Should never get here with an active SPS extension flag.
+          break;
+        }
+      }
+    }
+  }
 #else
   WRITE_FLAG( pcSPS->getSpsExtensionPresentFlag(), "sps_extension_present_flag" );
@@ -820,17 +952,23 @@
   if ( pcSPS->getSpsExtensionPresentFlag() )
   {
-    WRITE_FLAG( pcSPS->getSpsRangeExtensionsFlag( ) ? 1 : 0 , "sps_range_extensions_flag" );
+    WRITE_FLAG( pcSPS->getSpsRangeExtensionsFlag( )     ? 1 : 0 , "sps_range_extensions_flag" );
     WRITE_FLAG( pcSPS->getSpsMultilayerExtensionFlag( ) ? 1 : 0 , "sps_multilayer_extension_flag" );
-#if !H_3D
-    WRITE_CODE( pcSPS->getSpsExtension6bits( ), 6, "sps_extension_6bits" );  
-#else
-    WRITE_FLAG( pcSPS->getSps3dExtensionFlag( ) ? 1 : 0 , "sps_3d_extension_flag" );
-    WRITE_CODE( pcSPS->getSpsExtension5bits( ), 5, "sps_extension_5bits" );
-#endif
+    WRITE_FLAG( pcSPS->getSps3dExtensionFlag( )         ? 1 : 0 , "sps_3d_extension_flag" );
+    WRITE_CODE( pcSPS->getSpsExtension5bits( )              , 5 , "sps_extension_5bits" );
   }
 
   if ( pcSPS->getSpsRangeExtensionsFlag() )
   {
-    assert( 0 ); 
+    const TComSPSRExt &spsRangeExtension=pcSPS->getSpsRangeExtension();
+
+    WRITE_FLAG( (spsRangeExtension.getTransformSkipRotationEnabledFlag() ? 1 : 0),      "transform_skip_rotation_enabled_flag");
+    WRITE_FLAG( (spsRangeExtension.getTransformSkipContextEnabledFlag() ? 1 : 0),       "transform_skip_context_enabled_flag");
+    WRITE_FLAG( (spsRangeExtension.getRdpcmEnabledFlag(RDPCM_SIGNAL_IMPLICIT) ? 1 : 0), "implicit_rdpcm_enabled_flag" );
+    WRITE_FLAG( (spsRangeExtension.getRdpcmEnabledFlag(RDPCM_SIGNAL_EXPLICIT) ? 1 : 0), "explicit_rdpcm_enabled_flag" );
+    WRITE_FLAG( (spsRangeExtension.getExtendedPrecisionProcessingFlag() ? 1 : 0),       "extended_precision_processing_flag" );
+    WRITE_FLAG( (spsRangeExtension.getIntraSmoothingDisabledFlag() ? 1 : 0),            "intra_smoothing_disabled_flag" );
+    WRITE_FLAG( (spsRangeExtension.getHighPrecisionOffsetsEnabledFlag() ? 1 : 0),       "high_precision_offsets_enabled_flag" );
+    WRITE_FLAG( (spsRangeExtension.getPersistentRiceAdaptationEnabledFlag() ? 1 : 0),   "persistent_rice_adaptation_enabled_flag" );
+    WRITE_FLAG( (spsRangeExtension.getCabacBypassAlignmentEnabledFlag() ? 1 : 0),       "cabac_bypass_alignment_enabled_flag" );
   }
 
@@ -840,5 +978,5 @@
   }
 
-#if H_3D
+#if NH_3D
   if ( pcSPS->getSps3dExtensionFlag() )
   {
@@ -848,9 +986,9 @@
 #endif
 #endif
-
-}
-
-#if H_MV
-Void TEncCavlc::codeSPSExtension( TComSPS* pcSPS )
+  xWriteRbspTrailingBits();
+}
+
+#if NH_MV
+Void TEncCavlc::codeSPSExtension( const TComSPS* pcSPS )
 {
   WRITE_FLAG( pcSPS->getInterViewMvVertConstraintFlag() ? 1 : 0, "inter_view_mv_vert_constraint_flag" );
@@ -858,5 +996,5 @@
 
 
-Void TEncCavlc::codePPSMultilayerExtension(TComPPS* pcPPS)
+Void TEncCavlc::codePpsMultilayerExtension(const TComPPS* pcPPS)
 {
   WRITE_FLAG( pcPPS->getPocResetInfoPresentFlag( ) ? 1 : 0 , "poc_reset_info_present_flag" );
@@ -873,8 +1011,8 @@
 #endif
 
-#if H_3D
-Void TEncCavlc::codeSPS3dExtension( TComSPS* pcSPS )
-{
-  TComSps3dExtension* sps3dExt = pcSPS->getSps3dExtension();
+#if NH_3D
+Void TEncCavlc::codeSPS3dExtension( const TComSPS* pcSPS )
+{
+  const TComSps3dExtension* sps3dExt = pcSPS->getSps3dExtension();
   for( Int d = 0; d  <=  1; d++ )
   {
@@ -904,24 +1042,30 @@
 
 
-
-
-Void TEncCavlc::codeVPS( TComVPS* pcVPS )
-{
+Void TEncCavlc::codeVPS( const TComVPS* pcVPS )
+{
+#if ENC_DEC_TRACE
+#if H_MV_ENC_DEC_TRAC
+  tracePSHeader( "VPS", getEncTop()->getLayerId() ); 
+#else
+  xTraceVPSHeader();
+#endif
+#endif
   WRITE_CODE( pcVPS->getVPSId(),                    4,        "vps_video_parameter_set_id" );
-#if H_MV
+#if NH_MV
   WRITE_FLAG( pcVPS->getVpsBaseLayerInternalFlag( ) ? 1 : 0 , "vps_base_layer_internal_flag" );
   WRITE_FLAG( pcVPS->getVpsBaseLayerAvailableFlag( ) ? 1 : 0 , "vps_base_layer_available_flag" );
 #else
-  WRITE_CODE( 3,                                    2,        "vps_reserved_three_2bits" );
-#endif
-#if H_MV
+  WRITE_FLAG(                                       1,        "vps_base_layer_internal_flag" );
+  WRITE_FLAG(                                       1,        "vps_base_layer_available_flag" );
+#endif
+#if NH_MV
   WRITE_CODE( pcVPS->getMaxLayersMinus1(),       6,        "vps_max_layers_minus1" );
 #else
-  WRITE_CODE( 0,                                    6,        "vps_reserved_zero_6bits" );
+  WRITE_CODE( 0,                                    6,        "vps_max_layers_minus1" );
 #endif
   WRITE_CODE( pcVPS->getMaxTLayers() - 1,           3,        "vps_max_sub_layers_minus1" );
   WRITE_FLAG( pcVPS->getTemporalNestingFlag(),                "vps_temporal_id_nesting_flag" );
   assert (pcVPS->getMaxTLayers()>1||pcVPS->getTemporalNestingFlag());
-  WRITE_CODE( 0xffff,                              16,        "vps_reserved_ffff_16bits" );
+  WRITE_CODE( 0xffff,                              16,        "vps_reserved_0xffff_16bits" );
   codePTL( pcVPS->getPTL(), true, pcVPS->getMaxTLayers() - 1 );
   const Bool subLayerOrderingInfoPresentFlag = 1;
@@ -930,5 +1074,5 @@
   {
     WRITE_UVLC( pcVPS->getMaxDecPicBuffering(i) - 1,       "vps_max_dec_pic_buffering_minus1[i]" );
-    WRITE_UVLC( pcVPS->getNumReorderPics(i),               "vps_num_reorder_pics[i]" );
+    WRITE_UVLC( pcVPS->getNumReorderPics(i),               "vps_max_num_reorder_pics[i]" );
     WRITE_UVLC( pcVPS->getMaxLatencyIncrease(i),           "vps_max_latency_increase_plus1[i]" );
     if (!subLayerOrderingInfoPresentFlag)
@@ -937,6 +1081,7 @@
     }
   }
+
   assert( pcVPS->getNumHrdParameters() <= MAX_VPS_NUM_HRD_PARAMETERS );
-#if H_MV
+#if NH_MV
   assert( pcVPS->getVpsMaxLayerId() < MAX_VPS_NUH_LAYER_ID_PLUS1 );
   WRITE_CODE( pcVPS->getVpsMaxLayerId(), 6,                 "vps_max_layer_id" );  
@@ -949,7 +1094,6 @@
 #else
   assert( pcVPS->getMaxNuhReservedZeroLayerId() < MAX_VPS_NUH_RESERVED_ZERO_LAYER_ID_PLUS1 );
-  WRITE_CODE( pcVPS->getMaxNuhReservedZeroLayerId(), 6,     "vps_max_nuh_reserved_zero_layer_id" );
-  pcVPS->setMaxOpSets(1);
-  WRITE_UVLC( pcVPS->getMaxOpSets() - 1,                    "vps_max_op_sets_minus1" );
+  WRITE_CODE( pcVPS->getMaxNuhReservedZeroLayerId(), 6,     "vps_max_layer_id" );
+  WRITE_UVLC( pcVPS->getMaxOpSets() - 1,                    "vps_num_layer_sets_minus1" );
   for( UInt opsIdx = 1; opsIdx <= ( pcVPS->getMaxOpSets() - 1 ); opsIdx ++ )
   {
@@ -958,10 +1102,10 @@
     {
       // Only applicable for version 1
-      pcVPS->setLayerIdIncludedFlag( true, opsIdx, i );
+      // pcVPS->setLayerIdIncludedFlag( true, opsIdx, i );
 #endif
       WRITE_FLAG( pcVPS->getLayerIdIncludedFlag( opsIdx, i ) ? 1 : 0, "layer_id_included_flag[opsIdx][i]" );
     }
   }
-  TimingInfo *timingInfo = pcVPS->getTimingInfo();
+  const TimingInfo *timingInfo = pcVPS->getTimingInfo();
   WRITE_FLAG(timingInfo->getTimingInfoPresentFlag(),          "vps_timing_info_present_flag");
   if(timingInfo->getTimingInfoPresentFlag())
@@ -974,28 +1118,25 @@
       WRITE_UVLC(timingInfo->getNumTicksPocDiffOneMinus1(),   "vps_num_ticks_poc_diff_one_minus1");
     }
-    pcVPS->setNumHrdParameters( 0 );
     WRITE_UVLC( pcVPS->getNumHrdParameters(),                 "vps_num_hrd_parameters" );
 
     if( pcVPS->getNumHrdParameters() > 0 )
     {
-      pcVPS->createHrdParamBuffer();
-    }
-    for( UInt i = 0; i < pcVPS->getNumHrdParameters(); i ++ )
-    {
-      // Only applicable for version 1
-      pcVPS->setHrdOpSetIdx( 0, i );
-      WRITE_UVLC( pcVPS->getHrdOpSetIdx( i ),                "hrd_op_set_idx" );
-      if( i > 0 )
-      {
-        WRITE_FLAG( pcVPS->getCprmsPresentFlag( i ) ? 1 : 0, "cprms_present_flag[i]" );
-      }
-      codeHrdParameters(pcVPS->getHrdParameters(i), pcVPS->getCprmsPresentFlag( i ), pcVPS->getMaxTLayers() - 1);
-    }
-  }
-#if H_MV
+      for( UInt i = 0; i < pcVPS->getNumHrdParameters(); i ++ )
+      {
+        // Only applicable for version 1
+        WRITE_UVLC( pcVPS->getHrdOpSetIdx( i ),                "hrd_layer_set_idx" );
+        if( i > 0 )
+        {
+          WRITE_FLAG( pcVPS->getCprmsPresentFlag( i ) ? 1 : 0, "cprms_present_flag[i]" );
+        }
+        codeHrdParameters(pcVPS->getHrdParameters(i), pcVPS->getCprmsPresentFlag( i ), pcVPS->getMaxTLayers() - 1);
+      }
+    }
+  }
+#if NH_MV
   WRITE_FLAG( pcVPS->getVpsExtensionFlag(),                     "vps_extension_flag" );
   m_pcBitIf->writeAlignOne();
   codeVPSExtension( pcVPS );                           
-#if H_3D
+#if NH_3D
   WRITE_FLAG( 1,                     "vps_extension2_flag" );  
   WRITE_FLAG( 1,                     "vps_3d_extension_flag" );
@@ -1009,13 +1150,11 @@
   WRITE_FLAG( 0,                     "vps_extension_flag" );
 #endif
+
   //future extensions here..
-
-  return;
-}
-
-
-
-#if H_MV
-Void TEncCavlc::codeVPSExtension( TComVPS *pcVPS ) 
+  xWriteRbspTrailingBits();
+}
+
+#if NH_MV
+Void TEncCavlc::codeVPSExtension( const TComVPS *pcVPS ) 
 { 
   if( pcVPS->getMaxLayersMinus1() > 0  &&  pcVPS->getVpsBaseLayerInternalFlag() )
@@ -1037,6 +1176,6 @@
 
   if ( pcVPS->getSplittingFlag() )
-  {
-    pcVPS->setDimensionIdLen( pcVPS->getNumScalabilityTypes( ) - 1 ,pcVPS->inferLastDimsionIdLenMinus1() + 1 );       
+  {   
+    assert( pcVPS->getDimensionIdLen( pcVPS->getNumScalabilityTypes( ) - 1 ) == pcVPS->inferLastDimsionIdLenMinus1() + 1 );
   }    
 
@@ -1213,9 +1352,7 @@
   for (Int i = 0; i <= pcVPS->getVpsNumRepFormatsMinus1(); i++ )
   {    
-
-    TComRepFormat* curRepFormat = pcVPS->getRepFormat(i);     
-    TComRepFormat* prevRepFormat = i > 0 ? pcVPS->getRepFormat( i - 1) : NULL; 
+    const TComRepFormat* curRepFormat = pcVPS->getRepFormat(i);     
+    const TComRepFormat* prevRepFormat = i > 0 ? pcVPS->getRepFormat( i - 1) : NULL; 
     codeRepFormat( i, curRepFormat ,  prevRepFormat); 
-
   }
 
@@ -1291,12 +1428,12 @@
   else
   {
-    TComVPSVUI* pcVPSVUI = pcVPS->getVPSVUI( ); 
+    const TComVPSVUI* pcVPSVUI = pcVPS->getVPSVUI( ); 
     assert( pcVPSVUI ); 
-    pcVPSVUI->inferVpsVui( true ); 
-  }
-
-}
-
-Void TEncCavlc::codeVideoSignalInfo( TComVideoSignalInfo* pcVideoSignalInfo )
+    assert( !pcVPSVUI->getCrossLayerIrapAlignedFlag() );     
+  }
+
+}
+
+Void TEncCavlc::codeVideoSignalInfo( const TComVideoSignalInfo* pcVideoSignalInfo )
 {
   assert( pcVideoSignalInfo ); 
@@ -1308,8 +1445,7 @@
 }
 
-Void TEncCavlc::codeDpbSize( TComVPS* vps )
+Void TEncCavlc::codeDpbSize( const TComVPS* vps )
 { 
-  TComDpbSize* dpbSize = vps->getDpbSize(); 
-  assert ( dpbSize != 0 ); 
+  const TComDpbSize * dpbSize = vps->getDpbSize(); 
 
   for( Int i = 1; i < vps->getNumOutputLayerSets(); i++ )
@@ -1361,5 +1497,5 @@
 }
 
-Void TEncCavlc::codeRepFormat( Int i, TComRepFormat* pcRepFormat, TComRepFormat* pcPrevRepFormat )
+Void TEncCavlc::codeRepFormat( Int i, const TComRepFormat* pcRepFormat, const TComRepFormat* pcPrevRepFormat )
 {
   assert( pcRepFormat ); 
@@ -1384,5 +1520,5 @@
   else
   {
-    pcRepFormat->inferChromaAndBitDepth(pcPrevRepFormat, true ); 
+    pcRepFormat->checkInferChromaAndBitDepth(pcPrevRepFormat ); 
   }
   WRITE_FLAG( pcRepFormat->getConformanceWindowVpsFlag( ) ? 1 : 0 , "conformance_window_vps_flag" );
@@ -1396,9 +1532,9 @@
 }
 
-Void TEncCavlc::codeVPSVUI( TComVPS* pcVPS )
+Void TEncCavlc::codeVPSVUI( const TComVPS* pcVPS )
 {
   assert( pcVPS ); 
 
-  TComVPSVUI* pcVPSVUI = pcVPS->getVPSVUI( ); 
+  const TComVPSVUI* pcVPSVUI = pcVPS->getVPSVUI( ); 
 
   assert( pcVPSVUI ); 
@@ -1457,5 +1593,5 @@
   {
     assert( pcVPSVUI->getVideoSignalInfo( i ) != NULL ); 
-    TComVideoSignalInfo* curVideoSignalInfo = pcVPSVUI->getVideoSignalInfo( i ); 
+    const TComVideoSignalInfo* curVideoSignalInfo = pcVPSVUI->getVideoSignalInfo( i ); 
     codeVideoSignalInfo( curVideoSignalInfo );     
 
@@ -1543,13 +1679,13 @@
 }
 
-Void TEncCavlc::codeVpsVuiBspHrdParameters( TComVPS* pcVPS )
+Void TEncCavlc::codeVpsVuiBspHrdParameters( const TComVPS* pcVPS )
 {
   assert( pcVPS ); 
 
-  TComVPSVUI* pcVPSVUI = pcVPS->getVPSVUI( ); 
+  const TComVPSVUI* pcVPSVUI = pcVPS->getVPSVUI( ); 
 
   assert( pcVPSVUI ); 
 
-  TComVpsVuiBspHrdParameters*  vpsVuiBspHrdP = pcVPSVUI->getVpsVuiBspHrdParameters(); 
+  const TComVpsVuiBspHrdParameters*  vpsVuiBspHrdP = pcVPSVUI->getVpsVuiBspHrdParameters(); 
 
   assert ( vpsVuiBspHrdP );
@@ -1564,5 +1700,5 @@
     }
     WRITE_UVLC( vpsVuiBspHrdP->getNumSubLayerHrdMinus1( i ), "num_sub_layer_hrd_minus1" );
-    TComHRD* hrdParameters = vpsVuiBspHrdP->getHrdParametermeters( i ); 
+    const TComHRD* hrdParameters = vpsVuiBspHrdP->getHrdParametermeters( i ); 
     codeHrdParameters( hrdParameters, vpsVuiBspHrdP->getCprmsAddPresentFlag( i ), vpsVuiBspHrdP->getNumSubLayerHrdMinus1( i ) );     
   }
@@ -1599,10 +1735,9 @@
     }
   }  
-
 }  
 #endif
 
-#if H_3D
-Void TEncCavlc::codeVPS3dExtension( TComVPS* pcVPS )
+#if NH_3D
+Void TEncCavlc::codeVPS3dExtension( const TComVPS* pcVPS )
 { 
   WRITE_UVLC( pcVPS->getCpPrecision( ), "cp_precision" );
@@ -1634,42 +1769,39 @@
 #endif
 
+
 Void TEncCavlc::codeSliceHeader         ( TComSlice* pcSlice )
 {
-#if H_MV
-  TComVPS* vps = pcSlice->getVPS(); 
-#endif
-#if ENC_DEC_TRACE  
-  xTraceSliceHeader (pcSlice);
-#endif
+#if NH_MV
+  const TComVPS* vps = pcSlice->getVPS(); 
+#endif
+
+#if ENC_DEC_TRACE
+#if NH_MV
+  tracePSHeader( "Slice", pcSlice->getLayerId() ); 
+#else
+  xTraceSliceHeader ();
+#endif
+#endif
+
+  const ChromaFormat format                = pcSlice->getSPS()->getChromaFormatIdc();
+  const UInt         numberValidComponents = getNumberValidComponents(format);
+  const Bool         chromaEnabled         = isChromaEnabled(format);
 
   //calculate number of bits required for slice address
-  Int maxSliceSegmentAddress = pcSlice->getPic()->getNumCUsInFrame();
+  Int maxSliceSegmentAddress = pcSlice->getPic()->getNumberOfCtusInFrame();
   Int bitsSliceSegmentAddress = 0;
-  while(maxSliceSegmentAddress>(1<<bitsSliceSegmentAddress)) 
+  while(maxSliceSegmentAddress>(1<<bitsSliceSegmentAddress))
   {
     bitsSliceSegmentAddress++;
   }
-  Int ctuAddress;
-  if (pcSlice->isNextSlice())
-  {
-    // Calculate slice address
-    ctuAddress = (pcSlice->getSliceCurStartCUAddr()/pcSlice->getPic()->getNumPartInCU());
-  }
-  else
-  {
-    // Calculate slice address
-    ctuAddress = (pcSlice->getSliceSegmentCurStartCUAddr()/pcSlice->getPic()->getNumPartInCU());
-  }
+  const Int ctuTsAddress = pcSlice->getSliceSegmentCurStartCtuTsAddr();
+
   //write slice address
-  Int sliceSegmentAddress = pcSlice->getPic()->getPicSym()->getCUOrderMap(ctuAddress);
-
-  WRITE_FLAG( sliceSegmentAddress==0, "first_slice_segment_in_pic_flag" );
+  const Int sliceSegmentRsAddress = pcSlice->getPic()->getPicSym()->getCtuTsToRsAddrMap(ctuTsAddress);
+
+  WRITE_FLAG( sliceSegmentRsAddress==0, "first_slice_segment_in_pic_flag" );
   if ( pcSlice->getRapPicFlag() )
   {
-#if SETTING_NO_OUT_PIC_PRIOR
     WRITE_FLAG( pcSlice->getNoOutputPriorPicsFlag() ? 1 : 0, "no_output_of_prior_pics_flag" );
-#else
-    WRITE_FLAG( 0, "no_output_of_prior_pics_flag" );
-#endif
   }
 #if PPS_FIX_DEPTH
@@ -1680,17 +1812,18 @@
   else
 #endif
+
   WRITE_UVLC( pcSlice->getPPS()->getPPSId(), "slice_pic_parameter_set_id" );
-  pcSlice->setDependentSliceSegmentFlag(!pcSlice->isNextSlice());
-  if ( pcSlice->getPPS()->getDependentSliceSegmentsEnabledFlag() && (sliceSegmentAddress!=0) )
+  if ( pcSlice->getPPS()->getDependentSliceSegmentsEnabledFlag() && (sliceSegmentRsAddress!=0) )
   {
     WRITE_FLAG( pcSlice->getDependentSliceSegmentFlag() ? 1 : 0, "dependent_slice_segment_flag" );
   }
-  if(sliceSegmentAddress>0)
-  {
-    WRITE_CODE( sliceSegmentAddress, bitsSliceSegmentAddress, "slice_segment_address" );
+  if(sliceSegmentRsAddress>0)
+  {
+    WRITE_CODE( sliceSegmentRsAddress, bitsSliceSegmentAddress, "slice_segment_address" );
   }
   if ( !pcSlice->getDependentSliceSegmentFlag() )
   {
-#if H_MV    
+
+#if NH_MV    
     Int esb = 0;  //Don't use i, otherwise will shadow something below
 
@@ -1716,6 +1849,4 @@
     pcSlice->checkCrossLayerBlaFlag( ); 
 
-
-
     for (; esb < pcSlice->getPPS()->getNumExtraSliceHeaderBits(); esb++)    
 #else
@@ -1723,7 +1854,8 @@
 #endif
     {
-      assert(!!"slice_reserved_undetermined_flag[]");
-      WRITE_FLAG(0, "slice_reserved_undetermined_flag[]");
-    }
+      WRITE_FLAG(0, "slice_reserved_flag[]");
+    }
+
+
 
     WRITE_UVLC( pcSlice->getSliceType(),       "slice_type" );
@@ -1734,14 +1866,5 @@
     }
 
-    // in the first version chroma_format_idc is equal to one, thus colour_plane_id will not be present
-#if H_3D_DISABLE_CHROMA
-    assert (pcSlice->getSPS()->getChromaFormatIdc() == 1 || pcSlice->getIsDepth() );
-    assert (pcSlice->getSPS()->getChromaFormatIdc() == 0 || !pcSlice->getIsDepth() );
-#else
-    assert (pcSlice->getSPS()->getChromaFormatIdc() == 1 );
-#endif
-    // if( separate_colour_plane_flag  ==  1 )
-    //   colour_plane_id                                      u(2)
-#if H_MV
+#if NH_MV
     if ( (pcSlice->getLayerId() > 0 && !vps->getPocLsbNotPresentFlag( pcSlice->getLayerIdInVps())) || !pcSlice->getIdrPicFlag() )
     {
@@ -1752,12 +1875,13 @@
 
 #endif
+
     if( !pcSlice->getIdrPicFlag() )
     {
-#if !H_MV
+#if !NH_MV
       Int picOrderCntLSB = (pcSlice->getPOC()-pcSlice->getLastIDR()+(1<<pcSlice->getSPS()->getBitsForPOC())) & ((1<<pcSlice->getSPS()->getBitsForPOC())-1);
-      WRITE_CODE( picOrderCntLSB, pcSlice->getSPS()->getBitsForPOC(), "pic_order_cnt_lsb");
-#endif
-      TComReferencePictureSet* rps = pcSlice->getRPS();
-      
+      WRITE_CODE( picOrderCntLSB, pcSlice->getSPS()->getBitsForPOC(), "slice_pic_order_cnt_lsb");
+#endif
+      const TComReferencePictureSet* rps = pcSlice->getRPS();
+
       // check for bitstream restriction stating that:
       // If the current picture is a BLA or CRA picture, the value of NumPocTotalCurr shall be equal to 0.
@@ -1765,14 +1889,14 @@
       if (pcSlice->isIRAP())
       {
-          for (Int picIdx = 0; picIdx < rps->getNumberOfPictures(); picIdx++)
-          {
+        for (Int picIdx = 0; picIdx < rps->getNumberOfPictures(); picIdx++)
+        {
           assert (!rps->getUsed(picIdx));
-          }
-        }
+        }
+      }
 
       if(pcSlice->getRPSidx() < 0)
       {
         WRITE_FLAG( 0, "short_term_ref_pic_set_sps_flag");
-        codeShortTermRefPicSet(pcSlice->getSPS(), rps, true, pcSlice->getSPS()->getRPSList()->getNumberOfReferencePictureSets());
+        codeShortTermRefPicSet( rps, true, pcSlice->getSPS()->getRPSList()->getNumberOfReferencePictureSets());
       }
       else
@@ -1786,5 +1910,5 @@
         if (numBits > 0)
         {
-          WRITE_CODE( pcSlice->getRPSidx(), numBits, "short_term_ref_pic_set_idx" );          
+          WRITE_CODE( pcSlice->getRPSidx(), numBits, "short_term_ref_pic_set_idx" );
         }
       }
@@ -1796,7 +1920,13 @@
         UInt ltrpIndex;
         Int counter = 0;
-        for(Int k = rps->getNumberOfPictures()-1; k > rps->getNumberOfPictures()-rps->getNumberOfLongtermPictures()-1; k--) 
-        {
-          if (findMatchingLTRP(pcSlice, &ltrpIndex, rps->getPOC(k), rps->getUsed(k))) 
+        // WARNING: The following code only works only if a matching long-term RPS is 
+        //          found in the SPS for ALL long-term pictures
+        //          The problem is that the SPS coded long-term pictures are moved to the
+        //          beginning of the list which causes a mismatch when no reference picture
+        //          list reordering is used
+        //          NB: Long-term coding is currently not supported in general by the HM encoder
+        for(Int k = rps->getNumberOfPictures()-1; k > rps->getNumberOfPictures()-rps->getNumberOfLongtermPictures()-1; k--)
+        {
+          if (findMatchingLTRP(pcSlice, &ltrpIndex, rps->getPOC(k), rps->getUsed(k)))
           {
             ltrpInSPS[numLtrpInSPS] = ltrpIndex;
@@ -1809,4 +1939,6 @@
         }
         numLtrpInSH -= numLtrpInSPS;
+        // check that either all long-term pictures are coded in SPS or in slice header (no mixing)
+        assert (numLtrpInSH==0 || numLtrpInSPS==0); 
 
         Int bitsForLtrpInSPS = 0;
@@ -1815,5 +1947,5 @@
           bitsForLtrpInSPS++;
         }
-        if (pcSlice->getSPS()->getNumLongTermRefPicSPS() > 0) 
+        if (pcSlice->getSPS()->getNumLongTermRefPicSPS() > 0)
         {
           WRITE_UVLC( numLtrpInSPS, "num_long_term_sps");
@@ -1824,5 +1956,8 @@
         Int prevDeltaMSB = 0, prevLSB = 0;
         Int offset = rps->getNumberOfNegativePictures() + rps->getNumberOfPositivePictures();
-        for(Int i=rps->getNumberOfPictures()-1 ; i > offset-1; i--)
+        counter = 0;
+        // Warning: If some pictures are moved to ltrpInSPS, i is referring to a wrong index 
+        //          (mapping would be required)
+        for(Int i=rps->getNumberOfPictures()-1 ; i > offset-1; i--, counter++)
         {
           if (counter < numLtrpInSPS)
@@ -1830,11 +1965,11 @@
             if (bitsForLtrpInSPS > 0)
             {
-              WRITE_CODE( ltrpInSPS[counter], bitsForLtrpInSPS, "lt_idx_sps[i]");              
+              WRITE_CODE( ltrpInSPS[counter], bitsForLtrpInSPS, "lt_idx_sps[i]");
             }
           }
-          else 
+          else
           {
             WRITE_CODE( rps->getPocLSBLT(i), pcSlice->getSPS()->getBitsForPOC(), "poc_lsb_lt");
-            WRITE_FLAG( rps->getUsed(i), "used_by_curr_pic_lt_flag"); 
+            WRITE_FLAG( rps->getUsed(i), "used_by_curr_pic_lt_flag");
           }
           WRITE_FLAG( rps->getDeltaPocMSBPresentFlag(i), "delta_poc_msb_present_flag");
@@ -1853,5 +1988,5 @@
             }
             else
-            {              
+            {
               Int differenceInDeltaMSB = rps->getDeltaPocMSBCycleLT(i) - prevDeltaMSB;
               assert(differenceInDeltaMSB >= 0);
@@ -1865,15 +2000,15 @@
       if (pcSlice->getSPS()->getTMVPFlagsPresent())
       {
-#if H_MV
+#if NH_MV
         WRITE_FLAG( pcSlice->getEnableTMVPFlag() ? 1 : 0, "slice_temporal_mvp_enabled_flag" );
 #else
-        WRITE_FLAG( pcSlice->getEnableTMVPFlag() ? 1 : 0, "slice_temporal_mvp_enable_flag" );
-#endif
-      }
-    }
-#if H_MV
+        WRITE_FLAG( pcSlice->getEnableTMVPFlag() ? 1 : 0, "slice_temporal_mvp_enabled_flag" );
+#endif
+      }
+    }
+#if NH_MV
     Bool interLayerPredLayerIdcPresentFlag = false; 
     Int layerId = pcSlice->getLayerId(); 
-#if H_3D
+#if NH_3D
     if( pcSlice->getLayerId() > 0 && !vps->getAllRefLayersActiveFlag() && vps->getNumRefListLayers( layerId ) > 0 )
 #else
@@ -1882,5 +2017,5 @@
     {   
       WRITE_FLAG( pcSlice->getInterLayerPredEnabledFlag( ) ? 1 : 0 , "inter_layer_pred_enabled_flag" );
-#if H_3D
+#if NH_3D
       if( pcSlice->getInterLayerPredEnabledFlag() && vps->getNumRefListLayers( layerId ) > 1 )
 #else
@@ -1892,5 +2027,5 @@
           WRITE_CODE( pcSlice->getNumInterLayerRefPicsMinus1( ), pcSlice->getNumInterLayerRefPicsMinus1Len( ), "num_inter_layer_ref_pics_minus1" );
         }
-#if H_3D
+#if NH_3D
         if ( pcSlice->getNumActiveRefLayerPics() != vps->getNumRefListLayers( layerId ) )
 #else
@@ -1915,5 +2050,5 @@
 #endif
 
-#if H_3D      
+#if NH_3D      
   if( getEncTop()->decProcAnnexI() )
   {
@@ -1924,18 +2059,12 @@
   }
 #endif
+
     if(pcSlice->getSPS()->getUseSAO())
     {
-      if (pcSlice->getSPS()->getUseSAO())
-      {
-         WRITE_FLAG( pcSlice->getSaoEnabledFlag(), "slice_sao_luma_flag" );
-#if H_3D_DISABLE_CHROMA
-         if ( !pcSlice->getIsDepth() )
-         {
-         WRITE_FLAG( pcSlice->getSaoEnabledFlagChroma(), "slice_sao_chroma_flag" );
-      }
-#else
-         WRITE_FLAG( pcSlice->getSaoEnabledFlagChroma(), "slice_sao_chroma_flag" );
-#endif
-      }
+       WRITE_FLAG( pcSlice->getSaoEnabledFlag(CHANNEL_TYPE_LUMA), "slice_sao_luma_flag" );
+       if (chromaEnabled)
+       {
+         WRITE_FLAG( pcSlice->getSaoEnabledFlag(CHANNEL_TYPE_CHROMA), "slice_sao_chroma_flag" );
+       }
     }
 
@@ -1949,5 +2078,5 @@
 #endif
       WRITE_FLAG( overrideFlag ? 1 : 0,                               "num_ref_idx_active_override_flag");
-      if (overrideFlag) 
+      if (overrideFlag)
       {
         WRITE_UVLC( pcSlice->getNumRefIdx( REF_PIC_LIST_0 ) - 1,      "num_ref_idx_l0_active_minus1" );
@@ -1984,5 +2113,5 @@
             Int length = 1;
             numRpsCurrTempList0 --;
-            while ( numRpsCurrTempList0 >>= 1) 
+            while ( numRpsCurrTempList0 >>= 1)
             {
               length ++;
@@ -1996,5 +2125,5 @@
       }
       if(pcSlice->isInterB())
-      {    
+      {
         WRITE_FLAG(pcSlice->getRefPicListModification()->getRefPicListModificationFlagL1() ? 1 : 0,       "ref_pic_list_modification_flag_l1" );
         if (pcSlice->getRefPicListModification()->getRefPicListModificationFlagL1())
@@ -2017,5 +2146,5 @@
       }
     }
-    
+
     if (pcSlice->isInterB())
     {
@@ -2028,5 +2157,5 @@
       {
         SliceType sliceType   = pcSlice->getSliceType();
-        Int  encCABACTableIdx = pcSlice->getPPS()->getEncCABACTableIdx();
+        SliceType  encCABACTableIdx = pcSlice->getEncCABACTableIdx();
         Bool encCabacInitFlag = (sliceType!=encCABACTableIdx && encCABACTableIdx!=I_SLICE) ? true : false;
         pcSlice->setCabacInitFlag( encCabacInitFlag );
@@ -2080,12 +2209,23 @@
     }
     Int iCode = pcSlice->getSliceQp() - ( pcSlice->getPPS()->getPicInitQPMinus26() + 26 );
-    WRITE_SVLC( iCode, "slice_qp_delta" ); 
+    WRITE_SVLC( iCode, "slice_qp_delta" );
     if (pcSlice->getPPS()->getSliceChromaQpFlag())
     {
-      iCode = pcSlice->getSliceQpDeltaCb();
-      WRITE_SVLC( iCode, "slice_qp_delta_cb" );
-      iCode = pcSlice->getSliceQpDeltaCr();
-      WRITE_SVLC( iCode, "slice_qp_delta_cr" );
-    }
+      if (numberValidComponents > COMPONENT_Cb)
+      {
+        WRITE_SVLC( pcSlice->getSliceChromaQpDelta(COMPONENT_Cb), "slice_cb_qp_offset" );
+      }
+      if (numberValidComponents > COMPONENT_Cr)
+      {
+        WRITE_SVLC( pcSlice->getSliceChromaQpDelta(COMPONENT_Cr), "slice_cr_qp_offset" );
+      }
+      assert(numberValidComponents <= COMPONENT_Cr+1);
+    }
+
+    if (pcSlice->getPPS()->getPpsRangeExtension().getChromaQpOffsetListEnabledFlag())
+    {
+      WRITE_FLAG(pcSlice->getUseChromaQpAdj(), "cu_chroma_qp_offset_enabled_flag");
+    }
+
     if (pcSlice->getPPS()->getDeblockingFilterControlPresentFlag())
     {
@@ -2105,5 +2245,5 @@
     }
 
-    Bool isSAOEnabled = (!pcSlice->getSPS()->getUseSAO())?(false):(pcSlice->getSaoEnabledFlag()||pcSlice->getSaoEnabledFlagChroma());
+    Bool isSAOEnabled = pcSlice->getSPS()->getUseSAO() && (pcSlice->getSaoEnabledFlag(CHANNEL_TYPE_LUMA) || (chromaEnabled && pcSlice->getSaoEnabledFlag(CHANNEL_TYPE_CHROMA)));
     Bool isDBFEnabled = (!pcSlice->getDeblockingFilterDisable());
 
@@ -2112,5 +2252,5 @@
       WRITE_FLAG(pcSlice->getLFCrossSliceBoundaryFlag()?1:0, "slice_loop_filter_across_slices_enabled_flag");
     }
-#if H_3D
+#if NH_3D
     if (getEncTop()->decProcAnnexI() )
     {
@@ -2129,12 +2269,10 @@
     }
 #endif
-  }
-
-
-
-#if !H_MV
+
+  }
+#if !NH_MV
   if(pcSlice->getPPS()->getSliceHeaderExtensionPresentFlag())
   {
-    WRITE_UVLC(0,"slice_header_extension_length");
+    WRITE_UVLC(0,"slice_segment_header_extension_length");
   }
 #else
@@ -2244,28 +2382,25 @@
   }
 #endif 
-}
-
-Void TEncCavlc::codePTL( TComPTL* pcPTL, Bool profilePresentFlag, Int maxNumSubLayersMinus1)
+
+}
+
+Void TEncCavlc::codePTL( const TComPTL* pcPTL, Bool profilePresentFlag, Int maxNumSubLayersMinus1)
 {
   if(profilePresentFlag)
   {
-    codeProfileTier(pcPTL->getGeneralPTL());    // general_...
-  }
-  WRITE_CODE( pcPTL->getGeneralPTL()->getLevelIdc(), 8, "general_level_idc" );
+    codeProfileTier(pcPTL->getGeneralPTL(), false);    // general_...
+  }
+  WRITE_CODE( Int(pcPTL->getGeneralPTL()->getLevelIdc()), 8, "general_level_idc" );
 
   for (Int i = 0; i < maxNumSubLayersMinus1; i++)
   {
-#if !H_MV
-    if(profilePresentFlag)
-    {
-#endif
-      WRITE_FLAG( pcPTL->getSubLayerProfilePresentFlag(i), "sub_layer_profile_present_flag[i]" );
-#if !H_MV
-    }
-#endif
-    
+#if !NH_MV
+#endif
+    WRITE_FLAG( pcPTL->getSubLayerProfilePresentFlag(i), "sub_layer_profile_present_flag[i]" );
+#if !NH_MV
+#endif
     WRITE_FLAG( pcPTL->getSubLayerLevelPresentFlag(i),   "sub_layer_level_present_flag[i]" );
   }
-  
+
   if (maxNumSubLayersMinus1 > 0)
   {
